using System.Data.SqlClient;
using System.Data;
using C1.Win.FlexGrid;
using GrapeCity.DataVisualization.Chart;
using System.Windows.Forms;
using System.Xml.Linq;
//using GrapeCity.ActiveReports;
using C1.Win.List;
using static C1.Util.Win.Win32;
using System.Drawing;
using System.Data.OleDb;
//using GrapeCity.Enterprise.Data.DataEngine.DataProcessing;
//using GrapeCity.ActiveReports.Extensibility.Rendering;

namespace RouterBits
{

    public partial class Form1 : Form

    {
        
        String fstrConnection;
        SqlConnection Fcon;
        String fdbProvider;
        DataTable tbRouterBits;
        string strFolder;
        Boolean bolNeedToSave;
      
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
     
            strFolder = "F:\\RouterBitData\\Images\\";

            fstrConnection = @"Data Source = localhost; Initial Catalog = dbo.RouterBits;Integrated Security = True;";
            Fcon = new SqlConnection(fstrConnection);
            GetGroups();
            GetAllBits();
        }
        private void GetAllBits()
        {
            DataSet dsAllBits = new DataSet();

            SqlDataAdapter daAllBits ;
            String strFind;

           

            strFind = $"Select  tbRouterBits.counter, tbRouterBits.txtCode, tbRouterBits.intsize, tbRouterBits.txtDescription, tbRouterBits.txtNotes,  " +
                $"tbRouterBits.txtImageFile, tbRouterBits.txtImageDescription, tbGroups.txtDescription, tbGroups.ID from tbRouterBits join tbGroups ON tbGroups.ID =tbRouterBits.intGroup;";

            try
            {
                Fcon.Open();

                daAllBits = new SqlDataAdapter(strFind, Fcon);
                //dsAllBits.Clear();
                daAllBits.Fill(dsAllBits, "D");                         

                Fcon.Close();

                int numrowCount = 22;  // dsAllBits.Tables["D"].Rows.Count;
                
                if (numrowCount > 0)
                {
                    //DataSource is directly set to a DataTable, therefore no need to set DataMember
                    //Set DataMember only when you set DataSet as the DataSource (like the new code added below)
                    lstBits.DataSource = dsAllBits.Tables["D"];
                    //lstBits.DataMember = "txtDescription";


                    //this means that C1List will automatically pick table with name "D" from the DataSet
                    //lstBits.DataSource = dsAllBits;
                    //lstBits.DataMember = "D";
                }
            }
            catch (Exception ex)

            {
                MessageBox.Show("Error 4100: Error info: " + ex.Message);
            }
            finally
            {
            }
        }
        private void GetGroups()
        {
            String strFind;
            DataTable tbGroups;

            strFind = strFind = $"Select tbGroups.txtDescription, tbGroups.ID From tbGroups order by txtDescription";
            {
                try
                {

                    Fcon.Open();

                    SqlCommand cmd = new SqlCommand(strFind, Fcon);
                    tbGroups = new DataTable();
                    tbGroups.Load(cmd.ExecuteReader());

                    Fcon.Close();

                    int numrowCount = tbGroups.Rows.Count;
                    if (numrowCount > 0)
                    {


                        drpGroup.DataSource = tbGroups;
                        drpGroup.DataMember = "txtDescription";
                        drpGroup.ValueMember = "Id";
                        drpGroup.Splits[0].DisplayColumns[1].Visible = false;
                        drpGroup.Splits[0].DisplayColumns[0].Width = 200;
                        drpGroup.ColumnHeaders = false;

                        //  drpGroup.Splits[0].DisplayColumns[1].h

                        // txtStory.Text = Convert.ToString(dsStoryCharacter.Rows[0]["txtplot"]);

                        //  lstStoryCharacter.Splits[0].DisplayColumns[0].Visible = false;


                        bolNeedToSave = false;
                    }
                }

                catch (Exception ex)

                {
                    MessageBox.Show("Error 4200: Error info: " + ex.Message);
                }
                finally
                {

                }

            }
        }
        private void c1Button1_Click(object sender, EventArgs e)
        {
            //  imgBitImage.Image = Image.FromFile("F:\\RouterBitData\\Images\\TC 708 B.png");
            // imgBidDims.Image = Image.FromFile("F:\\RouterBitData\\Images\\TC 708 B Dims.png");
            txtImageFile.Text = "StraightBit";
            txtImageDescription.Text = "StraightBitDims";
            try
            {

            }
            catch (Exception ex)

            {
                MessageBox.Show("Error 6000: Error info: " + ex.Message);
            }
        }


        private void ShowABit()
        {

            String strFind = $"Select tbRouterBits.* From tbRouterBits WHERE tbRouterBits.counter = " + numCounter.Value;
            String strFile;
            String strFileDim = "";
            //     MessageBox.Show(strFind);

            try
            {
                Fcon.Open();

                SqlCommand cmd = new SqlCommand(strFind, Fcon);
                tbRouterBits = new DataTable();
                tbRouterBits.Load(cmd.ExecuteReader());

                Fcon.Close();

                int numrowCount = tbRouterBits.Rows.Count;
                if (numrowCount > 0)
                {
                    txtCode.Text = Convert.ToString(tbRouterBits.Rows[0]["txtCode"]);
                    txtDescription.Text = Convert.ToString(tbRouterBits.Rows[0]["txtDescription"]);
                    txtImageFile.Text = Convert.ToString(tbRouterBits.Rows[0]["txtImageFile"]);
                    strFile = strFolder + Convert.ToString(tbRouterBits.Rows[0]["txtImageFile"]);
                    strFileDim = strFolder + Convert.ToString(tbRouterBits.Rows[0]["txtImageDescription"]);
                    txtImageDescription.Text = Convert.ToString(tbRouterBits.Rows[0]["txtImageDescription"]);
                    numSize.Value = tbRouterBits.Rows[0]["intSize"];
                    numGroup.Value = tbRouterBits.Rows[0]["intGroup"];
                    numCounter.Value = tbRouterBits.Rows[0]["Counter"];
                    //imgBitImage.Image = Image.FromFile(strFile);
                    //imgBidDims.Image = Image.FromFile(strFileDim);
                    txtNotes.Text = Convert.ToString(tbRouterBits.Rows[0]["txtNotes"]);


                    //  int  intX = Convert.ToInt32 (numGroup.Value);  // drpGroup.FindStringExact(2);
                    drpGroup.SelectedIndex = drpGroup.FindString(numGroup.Text, 0, 1);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error 5000: Error info: " + ex.Message);
            }
            finally
            {

            }
        }


        private void drpGroup_TextChanged(object sender, EventArgs e)
        {
            string strDescr;
            strDescr = drpGroup.Text;
            numGroup.Value = (drpGroup.SelectedValue?.ToString());

        }

        private void drpGroup_DoubleClick(object sender, EventArgs e)
        {
            //  int  intX = (int)drpGroup.FindStringExact(2);
            //  drpGroup.SelectedIndex = intX;
            //drpGroup.SelectedIndex = Convert.ToInt32(numGroup.Value);




        }

        private void c1Button2_Click(object sender, EventArgs e)
        {

            String strTemp;
            strTemp = txtDescription.Text;
            var replacement = strTemp.Replace("'", "''");
            String strNotes;
            strNotes = txtNotes.Text;
            var strNoted = strNotes.Replace("'", "''");

            string strUpdate = @"INSERT INTO tbRouterBits(txtCode, txtDescription, txtNotes, txtImageFile, txtImageDescription, intSize, intGroup) VALUES  " +
               " ('" + txtCode.Text +
                "','" + strTemp +
                "','" + strNoted +
                 "','" + txtImageFile.Text +
               "','" + txtImageDescription.Text +
               "'," + numSize.Value +
               "," + numGroup.Value + ");";
        
            // MessageBox.Show(strUpdate);
            try
            {
                Fcon = new SqlConnection(fstrConnection);

                Fcon.Open();

                SqlCommand command = new SqlCommand(strUpdate, Fcon);

                long numDone = command.ExecuteNonQuery();
                lstBits.Refresh();
                Fcon.Close();
                // GetAllBits();
            }
            catch (Exception ex)

            {
                MessageBox.Show("Error 20000: Error info: " + ex.Message);
            }
            finally
            { 


            }
        }

        private void lstBits_Click(object sender, EventArgs e)
        {

        }

        private void lstBits_DoubleClick(object sender, EventArgs e)
        {
            int intBitID;
            decimal NumBitID;
            intBitID = lstBits.SelectedIndex;
            NumBitID = Convert.ToDecimal(lstBits.GetDisplayText(intBitID, 0));
            numCounter.Value = NumBitID;
            ShowABit();


        }

        private void UpdateRecord()
        {
            String strMade;

            String strUpdate;
            SqlCommand Command;
            int intCash;

            /*
                        If chkCash.Checked = True Then
                            intCash = 1
                    Else
                        intCash = 0
                    End If
                            */



            String strTemp;
            {
                //        strTemp = txtName.Text
                //      strTemp = Replace(strTemp, "'", "''")
                // MessageBox.Show(strTemp)
                strUpdate = " UPDATE tbRouterBits SET  txtCode= '" + txtCode.Text +
                      "',  txtDescription = '" + txtDescription.Text +
                     "',  txtNotes = '" + txtNotes.Text +
                    "',  txtImageFile = '" + txtImageFile.Text +
                    "',  txtImageDescription = '" + txtImageDescription.Text +
                    "',  intSize = " + numSize.Value +
                    ",  intGroup = " + numGroup.Value +
                     ",   WHERE counter= " + numCounter.Value + ";";


                try
                {

                    Fcon = new SqlConnection(fstrConnection);

                    Fcon.Open();

                    SqlCommand command = new SqlCommand(strUpdate, Fcon);

                    long numDone = command.ExecuteNonQuery();
                    lstBits.Refresh();
                    Fcon.Close();
                    ///

                    Fcon.Open();


                    //   ShowProgressBar()

                }
                catch (Exception ex)

                {
                    MessageBox.Show("Error 20000: Error info: " + ex.Message);
                }
                finally
                {

                }

            }

        }

        private void c1Button3_Click(object sender, EventArgs e)
        {
                       GetAllBits();

            /* String strFind;


            strFind = $"Select  tbRouterBits.counter, tbRouterBits.txtCode, tbRouterBits.intsize, tbRouterBits.txtDescription, tbRouterBits.txtNotes,  " +
                $"tbRouterBits.txtImageFile, tbRouterBits.txtImageDescription, tbGroups.txtDescription, tbGroups.ID from tbRouterBits join tbGroups ON tbGroups.ID =tbRouterBits.intGroup;";

            try
            {
                Fcon.Open();

                SqlCommand cmd = new SqlCommand(strFind, Fcon);
                tbAllBits = new DataTable();
                tbAllBits.Load(cmd.ExecuteReader());

                Fcon.Close();
            }
            catch (Exception ex)

            {
                MessageBox.Show("Error 20000: Error info: " + ex.Message);
            }
            finally
            {
            */
            }
            
        }
    }
